# This file is generated by SciPy's build process
# It contains system_info results at the time of building this package.
from enum import Enum

__all__ = ["show"]
_built_with_meson = True


class DisplayModes(Enum):
    stdout = "stdout"
    dicts = "dicts"


def _cleanup(d):
    """
    Removes empty values in a `dict` recursively
    This ensures we remove values that Meson could not provide to CONFIG
    """
    if isinstance(d, dict):
        return { k: _cleanup(v) for k, v in d.items() if v != '' and _cleanup(v) != '' }
    else:
        return d


CONFIG = _cleanup(
    {
        "Compilers": {
            "c": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "14.2.1",
                "commands": r"gcc",
                "args": r"-O2, -fexceptions, -g, -grecord-gcc-switches, -pipe, -Wall, -Werror=format-security, -Wno-error=incompatible-pointer-types, -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3, -Wp,-D_GLIBCXX_ASSERTIONS, -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1, -fstack-protector-strong, -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1, -m32, -march=i686, -mtune=generic, -msse2, -mfpmath=sse, -mstackrealign, -fasynchronous-unwind-tables, -fstack-clash-protection",
                "linker args": r"-Wl,-z,relro, -Wl,--as-needed, -Wl,-z,pack-relative-relocs, -Wl,-z,now, -specs=/usr/lib/rpm/redhat/redhat-hardened-ld, -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1, -Wl,--build-id=sha1, -specs=/usr/lib/rpm/redhat/redhat-package-notes, -O2, -fexceptions, -g, -grecord-gcc-switches, -pipe, -Wall, -Werror=format-security, -Wno-error=incompatible-pointer-types, -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3, -Wp,-D_GLIBCXX_ASSERTIONS, -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1, -fstack-protector-strong, -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1, -m32, -march=i686, -mtune=generic, -msse2, -mfpmath=sse, -mstackrealign, -fasynchronous-unwind-tables, -fstack-clash-protection",
            },
            "cython": {
                "name": r"cython",
                "linker": r"cython",
                "version": r"3.0.11",
                "commands": r"cython",
                "args": r"",
                "linker args": r"",
            },
            "c++": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "14.2.1",
                "commands": r"g++",
                "args": r"-O2, -fexceptions, -g, -grecord-gcc-switches, -pipe, -Wall, -Werror=format-security, -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3, -Wp,-D_GLIBCXX_ASSERTIONS, -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1, -fstack-protector-strong, -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1, -m32, -march=i686, -mtune=generic, -msse2, -mfpmath=sse, -mstackrealign, -fasynchronous-unwind-tables, -fstack-clash-protection",
                "linker args": r"-Wl,-z,relro, -Wl,--as-needed, -Wl,-z,pack-relative-relocs, -Wl,-z,now, -specs=/usr/lib/rpm/redhat/redhat-hardened-ld, -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1, -Wl,--build-id=sha1, -specs=/usr/lib/rpm/redhat/redhat-package-notes, -O2, -fexceptions, -g, -grecord-gcc-switches, -pipe, -Wall, -Werror=format-security, -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3, -Wp,-D_GLIBCXX_ASSERTIONS, -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1, -fstack-protector-strong, -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1, -m32, -march=i686, -mtune=generic, -msse2, -mfpmath=sse, -mstackrealign, -fasynchronous-unwind-tables, -fstack-clash-protection",
            },
            "fortran": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "14.2.1",
                "commands": r"gfortran",
                "args": r"-O2, -fexceptions, -g, -grecord-gcc-switches, -pipe, -Wall, -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3, -Wp,-D_GLIBCXX_ASSERTIONS, -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1, -fstack-protector-strong, -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1, -m32, -march=i686, -mtune=generic, -msse2, -mfpmath=sse, -mstackrealign, -fasynchronous-unwind-tables, -fstack-clash-protection, -I/usr/lib/gfortran/modules",
                "linker args": r"-Wl,-z,relro, -Wl,--as-needed, -Wl,-z,pack-relative-relocs, -Wl,-z,now, -specs=/usr/lib/rpm/redhat/redhat-hardened-ld, -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1, -Wl,--build-id=sha1, -specs=/usr/lib/rpm/redhat/redhat-package-notes, -O2, -fexceptions, -g, -grecord-gcc-switches, -pipe, -Wall, -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3, -Wp,-D_GLIBCXX_ASSERTIONS, -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1, -fstack-protector-strong, -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1, -m32, -march=i686, -mtune=generic, -msse2, -mfpmath=sse, -mstackrealign, -fasynchronous-unwind-tables, -fstack-clash-protection, -I/usr/lib/gfortran/modules",
            },
            "pythran": {
                "version": r"0.17.0",
                "include directory": r"../../../../../../usr/lib/python3.13/site-packages/pythran"
            },
        },
        "Machine Information": {
            "host": {
                "cpu": r"i686",
                "family": r"x86",
                "endian": r"little",
                "system": r"linux",
            },
            "build": {
                "cpu": r"i686",
                "family": r"x86",
                "endian": r"little",
                "system": r"linux",
            },
            "cross-compiled": bool("False".lower().replace('false', '')),
        },
        "Build Dependencies": {
            "blas": {
                "name": "flexiblas",
                "found": bool("True".lower().replace('false', '')),
                "version": "3.4.4",
                "detection method": "pkgconfig",
                "include directory": r"/usr/include/flexiblas",
                "lib directory": r"/usr/lib",
                "openblas configuration": r"unknown",
                "pc file directory": r"/usr/lib/pkgconfig",
            },
            "lapack": {
                "name": "flexiblas",
                "found": bool("True".lower().replace('false', '')),
                "version": "3.4.4",
                "detection method": "pkgconfig",
                "include directory": r"/usr/include/flexiblas",
                "lib directory": r"/usr/lib",
                "openblas configuration": r"unknown",
                "pc file directory": r"/usr/lib/pkgconfig",
            },
            "pybind11": {
                "name": "pybind11",
                "version": "2.13.6",
                "detection method": "pkgconfig",
                "include directory": r"/include",
            },
        },
        "Python Information": {
            "path": r"/usr/bin/python3",
            "version": "3.13",
        },
    }
)


def _check_pyyaml():
    import yaml

    return yaml


def show(mode=DisplayModes.stdout.value):
    """
    Show libraries and system information on which SciPy was built
    and is being used

    Parameters
    ----------
    mode : {`'stdout'`, `'dicts'`}, optional.
        Indicates how to display the config information.
        `'stdout'` prints to console, `'dicts'` returns a dictionary
        of the configuration.

    Returns
    -------
    out : {`dict`, `None`}
        If mode is `'dicts'`, a dict is returned, else None

    Notes
    -----
    1. The `'stdout'` mode will give more readable
       output if ``pyyaml`` is installed

    """
    if mode == DisplayModes.stdout.value:
        try:  # Non-standard library, check import
            yaml = _check_pyyaml()

            print(yaml.dump(CONFIG))
        except ModuleNotFoundError:
            import warnings
            import json

            warnings.warn("Install `pyyaml` for better output", stacklevel=1)
            print(json.dumps(CONFIG, indent=2))
    elif mode == DisplayModes.dicts.value:
        return CONFIG
    else:
        raise AttributeError(
            f"Invalid `mode`, use one of: {', '.join([e.value for e in DisplayModes])}"
        )
